]> diplodocus.org Git - nmh/blobdiff - docs/contrib/build_nmh
Added debug statements to test-mhparam.
[nmh] / docs / contrib / build_nmh
index 0ff426928eb714aeaacf7dcd441c1d4af4796a47..25a02642c3aa05dee2aea3e2f6150b6186e13f98 100755 (executable)
@@ -3,8 +3,7 @@
 # Configures and builds nmh.
 # * This script must be invoked from an nmh source directory.
 # * This script retrieves configuration from the first existing nmh
-#   installation on your $PATH, if any, as well as any $EDITOR/$VISUAL
-#   and $PAGER environment variable settings.
+#   installation on your $PATH, if any.
 # * Unless the -y option is provided, this script then interactively
 #   walks you through confirmation of common configuration settings.
 #
 #   ncurses-devel
 #   cyrus-sasl-devel, if using sasl
 #   openssl-devel, if using TLS
+#   libcurl-devel, if using oauth
 #   autoconf and automake, with -s (see docs/README.developers for versions)
 #   rpm-build, with -r
 
 
-####
-#### OS-specific setup.
-####
-which=which
-ldd=ldd
-
 ####
 #### Interpret command arguments.
 ####
@@ -91,9 +85,7 @@ if [ $# -gt 0 ]; then
 fi
 
 #### Check to see that we're in a nmh source directory.
-if grep 'the authors of nmh' COPYRIGHT >/dev/null; then
-  :
-else
+if ! grep 'the authors of nmh' COPYRIGHT >/dev/null; then
   echo "$0: not in nmh source directory"
   exit 1
 fi
@@ -111,56 +103,74 @@ config_mts=smtp
 config_smtpservers=localhost
 config_sasl=n
 config_tls=n
-config_editor=vi
-for i in more less most cat; do
-  if which $i >/dev/null 2>&1; then
-    config_pager=$i
-    break
-  fi
-done
+config_oauth=n
 config_debug=n
 
+
+#### Find location of a program.  Bourne shell just puts the name in
+#### $0 if it's found from the PATH, so search that if necessary.
+finddir() {
+  case $1 in
+    */*) dirname "$1" ;;
+    *  ) IFS=:
+         for d in $PATH; do
+           [ -f "${d:=.}/$1"  -a  -x "$d/$1" ]  &&  printf %s "$d"  &&  break
+         done ;;
+  esac
+}
+
+#### Figure out whether or not to use -n with tail.
+case `printf 'OK\n' | tail -n 1 2>&1` in
+  OK) tail='tail -n ' ;;
+  *)  tail='tail -' ;;
+esac
+
 if install-mh -check >/dev/null 2>&1; then
   # Determine config options from installed nmh.
-  mhparam=`which mhparam`
-  mhbin=`dirname "$mhparam"`
+  mhbin=`finddir install-mh`
 
   config_prefix=`cd $mhbin/.. && pwd`
 
-  mtsconf=`dirname "$mhbin"`/etc/mts.conf
+  mtsconf=`mhparam etcdir`/mts.conf
   if [ -f "$mtsconf" ]; then
-    mts_entry=`grep '^mts:' $mtsconf`
+    mts_entry=`grep '^mts:' "$mtsconf"`
     if [ "$mts_entry" ]; then
-      mts=`echo $mts_entry | sed -e 's/^mts: *//'`
+      mts=`echo "$mts_entry" | sed -e 's/^mts: *//'`
       if [ "$mts"  -a  "$mts" != smtp ]; then
         config_mts="$mts"
       fi
     fi
 
-    mtsconfservers=`grep '^servers:' $mtsconf`
+    mtsconfservers=`grep '^servers:' "$mtsconf"`
     if [ "$mtsconfservers" ]; then
-      servers=`echo $mtsconfservers | sed -e 's/^servers: *//' -e 's/ /\\\ /g'`
+      servers=`echo "$mtsconfservers" | \
+               sed -e 's/^servers: *//' -e 's/ /\\\ /g'`
       [ "$servers" ]  &&  config_smtpservers="$servers"
     fi
   fi
 
-  if $ldd $mhbin/inc | grep sasl >/dev/null; then
-    config_sasl=y
-  fi
-
-  if $ldd $mhbin/inc | grep ssl >/dev/null; then
-    config_tls=y
+  if test -x "$mhbin/mhparam"; then
+    if mhparam sasl >/dev/null; then
+      case `$mhbin/mhparam sasl` in
+        *sasl*) config_sasl=y ;;
+      esac
+
+      case `$mhbin/mhparam tls` in
+        *tls*) config_tls=y ;;
+      esac
+
+      case `$mhbin/mhparam oauth` in
+        *oauth*) config_oauth=y ;;
+      esac
+    else
+      tput smso
+      echo "$0: SASL, TLS, and OAuth2 detection not supported with current nmh"
+      [ $yes -eq 1 ]  &&  echo "will not configure them in"
+      tput rmso
+    fi
   fi
 fi
 
-if [ "$EDITOR" ]; then
-  config_editor="$EDITOR"
-elif [ "$VISUAL" ]; then
-  config_editor="$VISUAL"
-fi
-
-[ "$PAGER" ]  &&  config_pager="$PAGER"
-
 [ $debug -ge 1 ]  &&  config_debug=y
 
 if [ $yes -eq 0 ]; then
@@ -173,7 +183,7 @@ if [ $yes -eq 0 ]; then
   read locking
   [ "$locking" ]  &&  config_locking="$locking"
 
-  printf 'MTS (smtp|sendmail) [%s]: ' $config_mts
+  printf 'MTS (smtp|sendmail/smtp|sendmail/pipe) [%s]: ' $config_mts
   read mts
   [ "$mts" ]  &&  config_mts="$mts"
 
@@ -200,13 +210,13 @@ if [ $yes -eq 0 ]; then
     config_tls=n
   fi
 
-  printf 'Default editor [%s]: ' $config_editor
-  read editor
-  [ "$editor" ]  &&  config_editor=$editor
-
-  printf 'Pager [%s]: ' $config_pager
-  read pager
-  [ "$pager" ]  &&  config_pager=$pager
+  printf 'OAuth2 support [%s]: ' $config_oauth
+  read response
+  if [ "$response" = y  -o  "$response" = Y ]; then
+    config_oauth=y
+  elif [ "$response" = n  -o  "$response" = N ]; then
+    config_oauth=n
+  fi
 
   #### Don't confirm debug here:  obey the -d option to this script.
 fi
@@ -224,13 +234,10 @@ config_opts="--prefix=$config_prefix"
   config_opts="$config_opts --with-cyrus-sasl"
 [ "$config_tls" = y ]  &&  \
   config_opts="$config_opts --with-tls"
-[ "$config_editor" ]  &&  \
-  config_opts="$config_opts --with-editor=$config_editor"
-[ "$config_pager" ]  &&  \
-  config_opts="$config_opts --with-pager=$config_pager"
+[ "$config_oauth" = y ]  &&  \
+  config_opts="$config_opts --with-oauth"
 [ $config_debug = y ]  &&  \
-  config_opts="$config_opts --enable-debug"
-
+  config_opts="$config_opts --enable-debug --enable-assert"
 
 #### dotlocking, the usual default, requires chgrp and chmod of inc.
 installpriv=
@@ -255,12 +262,10 @@ if [ -f Makefile ]; then
   fi
 fi
 
-/bin/rm -f $logfile
-if [ -f configure  -a  -f Makefile.in ]; then
-  :
-else
+/bin/rm -f "$logfile"
+if [ ! -f configure  -o  ! -f Makefile.in ]; then
   [ $verbose -ge 1 ]  &&  echo autoconfiguring . . .
-  ./autogen.sh >>$logfile 2>&1
+  ./autogen.sh >>"$logfile" 2>&1
 fi
 
 
@@ -268,64 +273,69 @@ fi
 #### Build.
 ####
 [ $verbose -ge 1 ]  &&  echo configuring . . .
-echo ./configure $config_opts ${smtpservers:+"$smtpservers"} >>$logfile 2>&1
-./configure $config_opts ${smtpservers:+"$smtpservers"} >>$logfile 2>&1
+echo ./configure $config_opts ${smtpservers:+"$smtpservers"} >>"$logfile" 2>&1
+./configure CFLAGS="${CFLAGS:+$CFLAGS }-g -O2 -ansi -pedantic" \
+            $config_opts ${smtpservers:+"$smtpservers"} >>"$logfile" 2>&1
 status=$?
 
 if [ $status -eq 0 ]; then
   [ $verbose -ge 1 ]  &&  echo building . . .
-  make >>$logfile 2>&1
+  make >>"$logfile" 2>&1
   status=$?
 
   if [ $status -eq 0 ]; then
-    if [ "${TESTS_SHELL}"x = x ]; then
+    if [ "$TESTS_SHELL"x = x ]; then
       #### Bonus:  use heirloom shell to test, if available, and if
       #### TESTS_SHELL hadn't already been set.
       heirloom_shell=/usr/lib/heirloom/5bin/sh
-      if [ -x "${heirloom_shell}" ]; then
-        TESTS_SHELL="${heirloom_shell}"; export TESTS_SHELL
+      if [ -x "$heirloom_shell" ]; then
+        TESTS_SHELL="$heirloom_shell"; export TESTS_SHELL
       fi
    fi
 
     [ $verbose -ge 1 ]  &&  echo testing . . .
-    checkoutput=`make $check 2>>$logfile`
+    checkoutput=`make $check AM_COLOR_TESTS=always 2>>"$logfile"`
     status=$?
 
     tests_summary=`echo "$checkoutput" | grep tests`
     #### If multiple tests not run, that line will be caught by the
     #### "grep tests" above.
     test_not_run=`echo "$checkoutput" | grep 'test was not run'`
+    fails=`echo "$checkoutput" | grep FAIL`
     if [ "$tests_summary" ]; then
-      echo '===================' >>$logfile
-      echo $tests_summary >>$logfile
-      [ "$test_not_run" ]  &&  echo "$test_not_run" >>$logfile
-      echo '===================' >>$logfile
+      echo '===================' >>"$logfile"
+      [ "$test_not_run" ]  &&  echo "$test_not_run" >>"$logfile"
+      [ "$fails" ]  &&  echo "$fails" >>"$logfile"
+      echo "$tests_summary" >>"$logfile"
+      echo '===================' >>"$logfile"
       [ "$check" = distcheck ]  &&  \
-        echo "$checkoutput" | tail -n 4 >>$logfile
+        echo "$checkoutput" | ${tail}4 >>"$logfile"
     fi
 
     if [ $status -eq 0 ]; then
       if [ $install -ge 1 ]; then
         [ $verbose -ge 1 ]  &&  echo installing . . .
-        ($installpriv make install) >/dev/null 2>>$logfile
+        ($installpriv make install) >/dev/null 2>>"$logfile"
         status=$?
       fi
 
       if [ $status -eq 0  -a  $build_rpm -ge 1 ]; then
         [ $verbose -ge 1 ]  &&  echo building rpm . . .
-        make rpm >/dev/null 2>>$logfile
+        make rpm >/dev/null 2>>"$logfile"
         status=$?
       fi
     fi
   fi
 fi
 
-grep 'Error' $logfile
-grep 'warn' $logfile
-if [ $status -ne 0 ]; then
+grep Error "$logfile"
+grep warn "$logfile"
+
+if [ $status -eq 0 ]; then
+  [ $verbose -ge 1 ]  &&  echo build completed successfully
+else
   echo build failed!
-  echo build log is in $logfile
+  echo build log is in "$logfile"
 fi
-[ $status -eq 0  -a  $verbose -ge 1 ]  &&  echo build completed successfully
 
 exit $status